Skip to main content

Binary Search - Medium Level - Question 1

Binary Search - Medium Level - Question 1


Leetcode 33 Search in Rotated Sorted Array

There is an integer array nums sorted in ascending order (with distinct values).

Prior to being passed to your function, nums is rotated at an unknown pivot index k (0 <= k < nums.length) such that the resulting array is [nums[k], nums[k+1], ..., nums[n-1], nums[0], nums[1], ..., nums[k-1]] (0-indexed). For example, [0,1,2,4,5,6,7] might be rotated at pivot index 3 and become [4,5,6,7,0,1,2].

Given the array nums after the rotation and an integer target, return the index of target if it is in nums, or -1 if it is not in nums.

You must write an algorithm with O(log n) runtime complexity.

Constraints:

1 <= nums.length <= 5000

-10^4 <= nums[i] <= 10^4

All values of nums are unique.

nums is guaranteed to be rotated at some pivot.

-10^4 <= target <= 10^4


Analysis:

This question is quite popular in interview.

Binary search should be the way to reach O(logn) time complexity, but this question is not easy to code, due to the boundary conditions.

One hidden condition is the value of the last element (or the first element). By comparing this value with the target (or the guessed value in binary search), we can determine which the half search range to be removed.


See the code below:

class Solution {
public:
    int search(vector<int>& nums, int target) {
        int left = 0, right = nums.size(), n = nums.size();
        while(left < right) {
            if(nums[left] == target) return left;
            if(nums[right-1] == target) return right - 1;
            int mid = left + (right - left) / 2;
            if(nums[mid] == target) return mid;
            if(nums[right-1] > target) {
                if(nums[mid] > nums[right-1]) left = mid + 1;
                else {
                    if(nums[mid] > target) right = mid;
                    else left = mid + 1;
                }
            }
            else {
                if(nums[mid] < nums[right-1]) right = mid;
                else {
                    if(nums[mid] < target) left = mid + 1;
                    else right = mid;
                }
            }
        }
        return left >= 0 && left < n && nums[left] == target? left : -1;
    }
};



Question 2

Leetcode 153 Find Minimum in Rotated Sorted Array

Suppose an array of length n sorted in ascending order is rotated between 1 and n times. For example, the array nums = [0,1,2,4,5,6,7] might become:

[4,5,6,7,0,1,2] if it was rotated 4 times.

[0,1,2,4,5,6,7] if it was rotated 7 times.

Notice that rotating an array [a[0], a[1], a[2], ..., a[n-1]] 1 time results in the array [a[n-1], a[0], a[1], a[2], ..., a[n-2]].

Given the sorted rotated array nums of unique elements, return the minimum element of this array.

You must write an algorithm that runs in O(log n) time.

Constraints:

n == nums.length

1 <= n <= 5000

-5000 <= nums[i] <= 5000

All the integers of nums are unique.

nums is sorted and rotated between 1 and n times.


Analysis:

This question is very similar to the first one, which is a good practice to code the binary search.

One of the key observations is that: the one element is smaller than the one on its left, then the element is the minimum. Thus we can always to check this during binary search.

In addition, we need to use the hidden condition: the value of the first element or the last element, to help determine the search range.


See the code below:

class Solution {
public:
    int findMin(vector<int>& nums) {
        int left = 0, right = nums.size();
        while(left < right) {
            // whole range is sorted
            if(nums[left] <= nums[right - 1]) return nums[left];
            int mid = left + (right - left) / 2;
            // check the left neighbor
            if(mid>0 && nums[mid] < nums[mid-1]) return nums[mid];
            if(nums[mid] >= nums[0]) left = mid + 1;
            else right = mid;
        }
        return nums[left];
    } 
};

In addition,

1. Once the smallest element is found, the largest one is also found;

2. How about having elements with the same value?


Question 3

Leetcode 475 Heaters

Winter is coming! During the contest, your first job is to design a standard heater with a fixed warm radius to warm all the houses.

Every house can be warmed, as long as the house is within the heater's warm radius range. 

Given the positions of houses and heaters on a horizontal line, return the minimum radius standard of heaters so that those heaters could cover all houses.

Notice that all the heaters follow your radius standard, and the warm radius will the same.

Constraints:

1 <= houses.length, heaters.length <= 3 * 10^4

1 <= houses[i], heaters[i] <= 10^9


Analysis:

This question is not easy to think through.

One way to think about it is that: for each house, we need to figure out the shortest distance to all the heaters. Then the largest value of these shortest distances should be the final answer.

Then the question becomes: for each house, how to determine the shortest distance to all the heaters.

To increase the time complexity, we can sort the heaters by their locations. Then do a binary search with the location of the house, to find the shortest distance. Done. 


See the code below:

class Solution {
public:
    int findRadius(vector<int>& houses, vector<int>& heaters) {
        int res = 0;
        sort(heaters.begin(), heaters.end());
        for(auto a : houses){
            auto left = upper_bound(heaters.begin(), heaters.end(), a);
            if(left == heaters.begin()) res = max(res, *left - a);
            else if(left == heaters.end()) res = max(res, a - *(left-1));
            else res = max(res, min(*left - a, a - *(left - 1)));
        }
        return res;
    }
};



Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...